    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------
    028     * CategoryLabelWidthType.java
    029     * ---------------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 24-Mar-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.axis;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * Represents the width types for a category label.
    048     */
    049    public final class CategoryLabelWidthType implements Serializable {
    050
    051        /** For serialization. */
    052        private static final long serialVersionUID = -6976024792582949656L;
    053
    054        /** Percentage of category. */
    055        public static final CategoryLabelWidthType
    056            CATEGORY = new CategoryLabelWidthType(
    057                "CategoryLabelWidthType.CATEGORY"
    058            );
    059
    060        /** Percentage of range. */
    061        public static final CategoryLabelWidthType
    062            RANGE = new CategoryLabelWidthType("CategoryLabelWidthType.RANGE");
    063
    064        /** The name. */
    065        private String name;
    066
    067        /**
    068         * Private constructor.
    069         *
    070         * @param name  the name (<code>null</code> not permitted).
    071         */
    072        private CategoryLabelWidthType(String name) {
    073            if (name == null) {
    074                throw new IllegalArgumentException("Null 'name' argument.");
    075            }
    076            this.name = name;
    077        }
    078
    079        /**
    080         * Returns a string representing the object.
    081         *
    082         * @return The string (never </code>null</code>).
    083         */
    084        public String toString() {
    085            return this.name;
    086        }
    087
    088        /**
    089         * Returns <code>true</code> if this object is equal to the specified
    090         * object, and <code>false</code> otherwise.
    091         *
    092         * @param obj  the other object.
    093         *
    094         * @return A boolean.
    095         */
    096        public boolean equals(Object obj) {
    097
    098            if (this == obj) {
    099                return true;
    100            }
    101            if (!(obj instanceof CategoryLabelWidthType)) {
    102                return false;
    103            }
    104            CategoryLabelWidthType t = (CategoryLabelWidthType) obj;
    105            if (!this.name.equals(t.toString())) {
    106                return false;
    107            }
    108            return true;
    109
    110        }
    111
    112        /**
    113         * Ensures that serialization returns the unique instances.
    114         *
    115         * @return The object.
    116         *
    117         * @throws ObjectStreamException if there is a problem.
    118         */
    119        private Object readResolve() throws ObjectStreamException {
    120            if (this.equals(CategoryLabelWidthType.CATEGORY)) {
    121                return CategoryLabelWidthType.CATEGORY;
    122            }
    123            else if (this.equals(CategoryLabelWidthType.RANGE)) {
    124                return CategoryLabelWidthType.RANGE;
    125            }
    126            return null;
    127        }
    128
    129    }